(*****************************************************************************)
(*                                                                           *)
(* Open Source License                                                       *)
(* Copyright (c) 2023 Functori --- <contact@functori.com>                    *)
(*                                                                           *)
(* Permission is hereby granted, free of charge, to any person obtaining a   *)
(* copy of this software and associated documentation files (the "Software"),*)
(* to deal in the Software without restriction, including without limitation *)
(* the rights to use, copy, modify, merge, publish, distribute, sublicense,  *)
(* and/or sell copies of the Software, and to permit persons to whom the     *)
(* Software is furnished to do so, subject to the following conditions:      *)
(*                                                                           *)
(* The above copyright notice and this permission notice shall be included   *)
(* in all copies or substantial portions of the Software.                    *)
(*                                                                           *)
(* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR*)
(* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *)
(* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL   *)
(* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER*)
(* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING   *)
(* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER       *)
(* DEALINGS IN THE SOFTWARE.                                                 *)
(*                                                                           *)
(*****************************************************************************)

(** This OCaml file implements the abstract `value` type for Factori's scenario
DSL, which has different constructors to represent various types of values. The
file also includes functions for mapping IDs and extracting contract names from
a `value`. Warning: this short summary was automatically generated and could be
incomplete or misleading. If you feel this is the case, please open an issue. *)

open Tzfunc.Proto

(* This module contains a description of values used inside our AST
   and functions for successfully mapping them into universes and
   subuniverses *)
type u_id = Universes.universe_id [@@deriving show, encoding]

(* There's two types of KT1s: static ones that we can hardcode in a
   scenario, and dynamic ones which will be obtained upon deployment
*)
type 'id kt1 =
  | StaticKt1 of string
  | IdKt1 of 'id
[@@deriving show, encoding]

type address = string [@@deriving show, encoding]

type identity = {
  sk : string;
  pk : A.pk;
  pkh : A.pkh;
}

type code = script_expr

(* There's two types of networks: a static one like "jakartanet" or
   "katmandunet" or "mainnet", and one given as a parameter to the
   scenario *)
type network =
  | SpecificNetwork of string
  | ParameterNetwork
[@@deriving show, encoding]

type 'id contract = 'id kt1 [@@deriving show]

type seed = int [@@deriving show, encoding]

type contract_name = string [@@deriving show, encoding]

type namedvalue = string list [@@deriving show]

(* Abstract representation of a deployment *)
type 'id deploy = {
  from : 'id;
  amount : 'id;
  network : 'id;
  storage : 'id;
  contract_name : contract_name;
}
[@@deriving show, encoding]

(* Abstract representation of a call *)
type 'id call = {
  from : 'id;
  amount : 'id;
  entrypoint : string;
  contract : 'id;
  network : 'id;
  param : 'id;
  contract_name : contract_name;
  assert_success : bool;
  msg : string;
}
[@@deriving show, encoding]

(* Blockchain error * pretty-printed error * call parameters *)
type 'id failedcall = Failed : string * string * 'id call -> 'id failedcall

let pp_failedcall _ ppf (Failed (berror, pretterror, _) : 'id failedcall) =
  Format.fprintf ppf "Failed(%s,%s,Call())" berror pretterror

let show_failedcall x f = Format.asprintf "%a" (pp_failedcall x) f

let pp_script_expr ppf se =
  Format.fprintf ppf "%s" (EzEncoding.construct script_expr_enc.json se)

let pp_code = pp_script_expr

let code_enc = script_expr_enc.json

let pp_micheline ppf _ = Format.fprintf ppf ""

let micheline_enc = micheline_enc.json

type amount = Z.t

let pp_amount ppf (z : amount) = Format.fprintf ppf "%s" (Z.to_string z)

let show_amount (z : amount) = Format.asprintf "%a" pp_amount z

let amount_enc = Json_encoding.conv Z.to_string Z.of_string Json_encoding.string

type func =
  | GetAddress
  | GetBalance
  | GetStorage
[@@deriving show, encoding]

(* The abstract OCaml interfaces generated by Factori provide a way to
   build values (e.g. parameters and storage) from a native OCaml type
   to an abstract value, representing an AST object of any type, which
   can then be fed to deploys or calls. *)
type abstractValue = AValue : 'a Abstract_value.value -> abstractValue

let pp_abstractValue ppf (AValue v) =
  Format.fprintf ppf "%a" Abstract_value.pp_value v

let abstractValue_enc =
  Json_encoding.conv
    (fun _ -> "TODO: some abstractValueEncoding")
    (fun s -> AValue (VString s))
    Json_encoding.string

(* unary value *)
type 'id uv =
  | Code_uv of code
  | Amount_uv of amount
  | Kt1_uv of 'id kt1
  | Network_uv of network
  | String_uv of string
  | Entrypoint_name_uv of string
  | Micheline_uv of micheline
  | Address_uv of address
  | Generate_key of seed
  | DefaultIdentity of network
  | Id of 'id
  | NativeAbstractValue of abstractValue
  | FunctionCall of func * 'id list
[@@deriving show]

(* An element of the AST of a scenario is either a unary value, a
   Deploy operation, a call operation, a (asserted) failed call, a
   fork (later yielding two or more parallel scenarios), a sequence of
   AST elements, or a checkpoint (not used for now, but might find
   some uses later). The type is parametered by the type of
   identifiers which may be strings such as "address0" or (identifier,
   universe) such as (17,[0;1]) *)
type 'id value =
  | Unary of 'id uv
  | Deploy of 'id deploy
  | Call of 'id call
  | FailedCall of 'id failedcall
  | Fork of ('id * 'id value) list
  | Seq of ('id * 'id value) list
  | PrintUnary of (string * 'id uv)
  | Checkpoint
[@@deriving show]

(** Retrieve all contract names so as to open the right modules in the
   generated scenarios *)
let extract_contract_names_from_value (v : 'id value) =
  let add x res =
    if List.mem x res then
      res
    else
      x :: res in
  let rec aux res = function
    | Unary _ -> res
    | Deploy d -> add d.contract_name res
    | Call c -> add c.contract_name res
    | Fork l | Seq l ->
      List.fold_right (fun (_, v1) cur_res -> aux cur_res v1) l res
    | FailedCall (Failed (_, _, call)) -> add call.contract_name res
    | Checkpoint | PrintUnary _ -> res in
  aux [] v

module AV = struct
  open Abstract_value

  type id1 = u_id

  type id2 = Scenario_id.id

  let rec map_value_id_tuple :
            'a.
            f:('b abstract_id -> 'c abstract_id) ->
            'a value tuple ->
            'a value tuple =
    fun (type a) ~(f : 'b abstract_id -> 'c abstract_id) (t : a value tuple) ->
     match t with
     | Single v ->
       let (v : a value) = map_value_id_abstract_value ~f v in
       Single v
     | Multi (v1, vrest) ->
       let (v1 : _ value) = map_value_id_abstract_value ~f v1 in
       let (vrest : _ value tuple) = map_value_id_tuple ~f vrest in
       Multi (v1, vrest)

  and map_value_id_sumtype :
        'a.
        f:('b abstract_id -> 'c abstract_id) ->
        'a abstract_or_type ->
        'a abstract_or_type =
    fun (type a) ~(f : 'b abstract_id -> 'c abstract_id)
        (t : a abstract_or_type) ->
     let res : a abstract_or_type =
       match t with
       | LeafOr (sn, v) ->
         let v = map_value_id_abstract_value ~f v in
         LeafOr (sn, v)
       | SumOrL o1 ->
         let o1 = map_value_id_sumtype ~f o1 in
         SumOrL o1
       | SumOrR o2 ->
         let o2 = map_value_id_sumtype ~f o2 in
         SumOrR o2 in
     res

  and map_value_id_abstract_paired_type :
        'a.
        f:('b abstract_id -> 'c abstract_id) ->
        'a abstract_paired_type ->
        'a abstract_paired_type =
    fun (type a) ~(f : 'b abstract_id -> 'c abstract_id)
        (t : a abstract_paired_type) ->
     let (res : a abstract_paired_type) =
       match t with
       | LeafP (sn, v) ->
         let v = map_value_id_abstract_value ~f v in
         LeafP (sn, v)
       | PairP (p1, p2) ->
         let p1 = map_value_id_abstract_paired_type ~f p1 in
         let p2 = map_value_id_abstract_paired_type ~f p2 in
         PairP (p1, p2) in
     res

  and map_value_id_abstract_value :
        'a. f:('b abstract_id -> 'c abstract_id) -> 'a value -> 'a value =
    fun (type a) ~(f : 'b abstract_id -> 'c abstract_id) (v : a value) ->
     match v with
     | VAbstract id ->
       let (res : a value) = VAbstract (convert (f (convert id))) in
       res
     | VInt i ->
       let (res : a value) = VInt i in
       res
     | VUnit u ->
       let (res : a value) = VUnit u in
       res
     | VString s ->
       let (res : a value) = VString s in
       res
     | VBytes b ->
       let (res : a value) = VBytes b in
       res
     | VTimestamp ts -> VTimestamp ts
     | VBool b -> VBool b
     | VAddress addr -> VAddress addr
     | VTez t -> VTez t
     | VKey k -> VKey k
     | VKeyHash kh -> VKeyHash kh
     | VSignature vs -> VSignature vs
     | VOperation o -> VOperation o
     | VOnChainBigMap i -> VOnChainBigMap i
     | VLiteralBigMap bm ->
       let (res : a value) =
         VLiteralBigMap
           (List.map
              (fun xy ->
                match xy with
                | SP xy -> SP (map_value_id_abstract_value ~f xy)
                | SP2 (x, y) ->
                  SP2
                    ( map_value_id_abstract_value ~f x,
                      map_value_id_abstract_value ~f y ))
              bm) in
       res
     | VMap m ->
       VMap
         (List.map
            (fun xy ->
              match xy with
              | SP xy -> SP (map_value_id_abstract_value ~f xy)
              | SP2 (x, y) ->
                SP2
                  ( map_value_id_abstract_value ~f x,
                    map_value_id_abstract_value ~f y ))
            m)
     | VSet s -> VSet (List.map (fun x -> map_value_id_abstract_value ~f x) s)
     | VList l -> VList (List.map (fun x -> map_value_id_abstract_value ~f x) l)
     | VOption None ->
       let (res : a value) = VOption None in
       res
     | VOption (Some v) ->
       let (res : a value) = VOption (Some (map_value_id_abstract_value ~f v)) in
       res
     | VLambda l -> VLambda l
     | VSumtype o ->
       let o = map_value_id_sumtype ~f o in
       VSumtype o
     | VChain_id ci -> VChain_id ci
     | VTicket t -> VTicket t
     | VSaplingState ss -> VSaplingState ss
     (* | _ -> failwith "coucou" *)
     | VRecord p ->
       let p = map_value_id_abstract_paired_type ~f p in
       VRecord p
     | VTuple t ->
       let (t : _ tuple) = map_value_id_tuple ~f t in
       VTuple t
end

(* I wish I didn't have to write such functions.. *)
let convert_unary (u : 'id1 uv) : 'id2 uv =
  match u with
  | Code_uv c -> Code_uv c
  | Amount_uv a -> Amount_uv a
  | Network_uv n -> Network_uv n
  | String_uv s -> String_uv s
  | Entrypoint_name_uv e -> Entrypoint_name_uv e
  | Micheline_uv m -> Micheline_uv m
  | Address_uv a -> Address_uv a
  | Generate_key s -> Generate_key s
  | DefaultIdentity n -> DefaultIdentity n
  | FunctionCall (_, _) | NativeAbstractValue _ ->
    failwith "should be processed in another case"
  | Id _ | Kt1_uv _ -> failwith "should be processed in another case"

(* let rec map_value_id_ntc ~f (ntc : 'id nativeContractType) =
 *   match ntc with
 *   | Unchanged -> Unchanged
 *   | Subst(id,name) -> Subst(f id,name)
 *   | Subfield(cn,ntc) -> Subfield(cn,map_value_id_ntc ~f ntc) *)

(* This is for f: u_id -> u_id *)
let map_unary ~(f : AV.id1 -> AV.id1) u =
  match u with
  | Id i -> Id (f i)
  | Kt1_uv (IdKt1 id) -> Kt1_uv (IdKt1 (f id))
  | FunctionCall (fu, l) -> FunctionCall (fu, List.map f l)
  | NativeAbstractValue (AValue v) ->
    let open Abstract_value in
    let f = function
      | UniId id -> UniId (f id)
      | ScenId id -> ScenId id in
    NativeAbstractValue (AValue (AV.map_value_id_abstract_value ~f v))
  | u -> convert_unary u

(* This is for f: u_id -> Scenario_id.id *)
let map_unary_different_types ~(f : AV.id2 -> AV.id1) u =
  match u with
  | Id i -> Id (f i)
  | Kt1_uv (IdKt1 id) -> Kt1_uv (IdKt1 (f id))
  | FunctionCall (fu, l) -> FunctionCall (fu, List.map f l)
  | NativeAbstractValue (AValue v) ->
    let open Abstract_value in
    let f = function
      | ScenId id -> UniId (f id)
      | UniId _id -> failwith "there should not be universe ids here" in
    NativeAbstractValue (AValue (AV.map_value_id_abstract_value ~f v))
  | u -> convert_unary u

(* This is for f: u_id -> u_id *)
let rec map_value_id ~(f : u_id -> u_id) v =
  match v with
  | Unary u -> Unary (map_unary ~f u)
  | PrintUnary (msg, u) -> PrintUnary (msg, map_unary ~f u)
  | Deploy deploy ->
    Deploy
      {
        from = f deploy.from;
        amount = f deploy.amount;
        network = f deploy.network;
        storage = f deploy.storage;
        contract_name = deploy.contract_name;
      }
  | Call call ->
    Call
      {
        amount = f call.amount;
        from = f call.from;
        contract = f call.contract;
        network = f call.network;
        param = f call.param;
        entrypoint = call.entrypoint;
        contract_name = call.contract_name;
        assert_success = call.assert_success;
        msg = call.msg;
      }
  | FailedCall (Failed (x, y, call)) ->
    FailedCall
      (Failed
         ( x,
           y,
           {
             amount = f call.amount;
             from = f call.from;
             contract = f call.contract;
             network = f call.network;
             param = f call.param;
             entrypoint = call.entrypoint;
             contract_name = call.contract_name;
             assert_success = call.assert_success;
             msg = call.msg;
           } ))
  | Fork l -> Fork (List.map (fun (id, v) -> (f id, map_value_id ~f v)) l)
  | Seq vl -> Seq (List.map (fun (id, v) -> (f id, map_value_id ~f v)) vl)
  | Checkpoint -> Checkpoint

(* This is for f: u_id -> Scenario_id.id *)
let rec map_value_id_different_types ~(f : AV.id2 -> AV.id1) v =
  match v with
  | Unary u -> Unary (map_unary_different_types ~f u)
  | PrintUnary (msg, u) -> PrintUnary (msg, map_unary_different_types ~f u)
  | Deploy deploy ->
    Deploy
      {
        from = f deploy.from;
        amount = f deploy.amount;
        network = f deploy.network;
        storage = f deploy.storage;
        contract_name = deploy.contract_name;
      }
  | Call call ->
    Call
      {
        amount = f call.amount;
        from = f call.from;
        contract = f call.contract;
        network = f call.network;
        param = f call.param;
        entrypoint = call.entrypoint;
        contract_name = call.contract_name;
        assert_success = call.assert_success;
        msg = call.msg;
      }
  | FailedCall (Failed (x, y, call)) ->
    FailedCall
      (Failed
         ( x,
           y,
           {
             amount = f call.amount;
             from = f call.from;
             contract = f call.contract;
             network = f call.network;
             param = f call.param;
             entrypoint = call.entrypoint;
             contract_name = call.contract_name;
             assert_success = call.assert_success;
             msg = call.msg;
           } ))
  | Fork l ->
    Fork (List.map (fun (id, v) -> (f id, map_value_id_different_types ~f v)) l)
  | Seq vl ->
    Seq (List.map (fun (id, v) -> (f id, map_value_id_different_types ~f v)) vl)
  | Checkpoint -> Checkpoint

let unary x = Unary x
